<?php 
    $id = $_GET["clanek"];

    $dotaz = $db->prepare("SELECT uzivatele.email AS email, clanky.datum, clanky.nadpis AS nadpis, clanky.text AS text, clanky.upraveno AS upraveno FROM clanky LEFT JOIN uzivatele ON clanky.id_autora = uzivatele.id WHERE clanky.id = ?");
    
    $dotaz -> bind_param("i", $id);
    $dotaz->execute();
    $vysledek = $dotaz->get_result();

    if ($vysledek->num_rows == 1) {
        $data = $vysledek->fetch_assoc();

        echo '<h2>'.$data["nadpis"].'</h2>
        <p>Autor: ';
        if($data["email"] == NULL){
            echo '<span style="font-style:italic">Smazaný uživatel</span>';
        }
        else {
            echo $data["email"];
        }
        echo '<br>
        Datum: '.date("j.n.Y H:i:s", $data["datum"]);
        if ($data["upraveno"] != NULL) {
            echo ', naposledy upraveno: '.date("j.n.Y H:i:s", $data["upraveno"]);
        }
        echo '</p><p>'.nl2br($data["text"], false).'</p>';
        if(isset($_SESSION["email"]) && $_SESSION["email"] == $data["email"]){
            echo '<p><a href="'.$root.'?edit='.$id.'">Upravit</a>
            <a href="'.$root.'?smaz'.$id.'" onclick="return confirm(\'Opravdu chcete smazat tento článek?\')">Smazat</a></p>';
        }
        echo '<hr>
        <h3>Komentáře</h3>';
        // pridat komentar, pouze pro prihlasene
        if (isset($_SESSION["email"])) {
            if(isset($_POST["nadpis"]) && isset($_POST["text"])){      // byl odeslan novy komentar
                $nadpis = $_POST["nadpis"];
                $text = $_POST["text"];
                $dotaz = $db ->prepare("SELECT id FROM uzivatele WHERE email LIKE ?");
                $dotaz->bind_param("s", $_SESSION["email"]);
                $dotaz->execute();
                $vysledek = $dotaz->get_result();
                $data = $vysledek->fetch_assoc();
                $id_autora = $data["id"];
                $datum = time();
                $dotaz = $db ->prepare("INSERT INTO komentare (id_autora, id_clanku, datum, nadpis, text) VALUES (?,?,?,?,?)");
                $dotaz -> bind_param("iiiss", $id_autora, $id, $datum, $nadpis, $text);
                $dotaz->execute();
                header("location:".$root."?clanek=".$id);
            }
            else {      // form na komentare
                echo '
                <p>Přidat nový komentář</p>
                <form method="post">
                <p>Nadpis: <input type="text" name="nadpis" maxlength="200" required><br>
                Text: <textarea name="text" cols="80" rows="5" required></textarea><br>
                <input type="submit" value="Přidat komentář"></p>
                </form>';
            }
        }
        else {
            echo '<p>Přidávat komentáře mohou jen přihlášení uživatelé</p>';
        }
        echo '<hr>';
        $dotaz = $db ->prepare("SELECT uzivatele.email AS email, komentare.id AS id, komentare.datum AS datum, komentare.nadpis AS nadpis, komentare.text AS text FROM komentare LEFT JOIN uzivatele ON komentare.id_autora = uzivatele.id WHERE komentare.id_clanku = ? ORDER BY komentare.datum ASC");
        $dotaz -> bind_param("i", $id);
        $dotaz->execute();
        $vysledek = $dotaz->get_result();
        while ($komentar = $vysledek->fetch_assoc()) {
            echo '<h5>'.$komentar["nadpis"].'</h5>
            <p>Autor: ';
            if($komentar["email"] == NULL){
                echo '<span style="font-style:italic">Smazaný uživatel</span>';
            }
            else {
                echo $komentar["email"];
            }
            echo '<br>
            Datum: '.date("j.n.Y H:i:s", $komentar["datum"]).'</p>
            <p>'.nl2br($komentar["text"], false).'</p>
            <hr>';
        }
    }
    else {
        echo '<h2>Chyba</h2>
        <p>Článek nebyl nalezen</p>
        <p>Pokračujte na <a href="'.$root.'">hlavní stránku</a></p>';
    }
?>