<?php
    ini_set('display_errors', 1);
?>

<!doctype html>
<html lang="cs">
    <head>
        <meta charset="utf-8">
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/css/bootstrap.min.css" rel="stylesheet">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/js/bootstrap.bundle.min.js"></script>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title></title>
    </head>
    <body>
        <?php
            $db = new mysqli("localhost", "root", "", "dinhth");
            $db -> set_charset("utf8");
            session_start();

            if(isset($_SESSION["email"])){              //prihlasen
                if(isset($_GET["odhlasit"])){
                    unset($_SESSION["email"]);
                    header("location:prihlaseni.php");
                }
                else if (isset($_GET["zmenahesla"])){
                    if (isset($_POST["heslo"])){    // zmena hesla v DB
                        $heslo = $_POST["heslo"];
                        $heslo = hash("sha512", $heslo);
                        $heslo = "nějaká sůl".$heslo."plus pepř";
                        $heslo = hash("sha512", $heslo);
                        $email = $_SESSION["email"];
                        $dotaz = $db->prepare("UPDATE uzivatele SET heslo = ? WHERE email LIKE ?");
                        $dotaz->bind_param("ss", $heslo, $email);
                        $dotaz->execute();
                        echo '<h2>Změna hesla</h2>
                        <p>Heslo bylo změněno<br>
                        Pokračujte na <a href="prihlaseni.php">hlavní stránku</a></p>';
                    }
                    else{   //formular pro zmenu
                        echo '<h2>Změna hesla</h2>
                        <form method="post">
                        <p>Nové heslo: <input type:"password" name="heslo" required><br>
                        <input type="submit" value="Změnit"></p>
                        </form>';
                    }
                }
                else{
                    echo'<p>Přihlášen: '.$_SESSION["email"].'<br>
                    <a href="prihlaseni.php?odhlasit">Odhlásit se</a> <a href="prihlaseni.php?zmenahesla">Změnit heslo</a></p>';
                }
            }
            
            else if(isset($_GET["registrace"])){        //chce se registrovat
                if(isset($_POST["email"]) && isset($_POST["heslo"])){       //odeslany formular
                    $email =  $_POST["email"];
                    $dotaz = $db->prepare("SELECT id FROM uzivatele WHERE email LIKE ?");
                    $dotaz->bind_param("s", $email);
                    $dotaz->execute();
                    $vysledek = $dotaz->get_result();
                    if($vysledek->num_rows == 1){       // email byl nalezen v databazi, neunikatni email
                        echo'<h2 style="color:red">Již registrován</h2>';
                    }  
                    else{
                        $heslo = $_POST["heslo"];
                        $heslo = hash("sha512", $heslo);
                        $heslo = "nějaká sůl".$heslo."plus pepř";
                        $heslo = hash("sha512", $heslo);
                        $kod = hash("crc32", time().$email.time().$heslo);

                        $dotaz = $db->prepare("INSERT INTO uzivatele (email, heslo, datum, kod) VALUES (?, ?, ?, ?)");
                        $datum = time();
                        $dotaz->bind_param("ssis", $email, $heslo, $datum, $kod);
                        $dotaz->execute();

                        echo'<h2 style="color:green">Registrováno</h2>
                        <p>Na váš E-Mail byl zaslán ověřovací kód. Před prvním přihlášením je potřeba ověřit E-Mail pomocí kódu.</p>
                        <p>Pokračujte na <a href="prihlaseni.php">přihlášení</a></p>';
                        $text = '<h1>Potvrzeni registrace</h1>
                        <p>Dobrý den,<br>
                        pro potvrzeni registrace kliknete na nasledujici odkaz<br>
                        <a href="http://localhost/dinhth/prihlaseni.php?overeni='.$email.'&kod='.$kod.'">http://localhost/dinhth/prihlaseni.php?overeni='.$email.'&kod='.$kod.'</a></p>';
                        //$hlavicky = nastaveni kodovani, odesilatele atd...
                        //mail($email, "overeni registrace", $text, $hlavicky)
                        echo $text; //normalne bychom zaslali mailem text, zde ale nejde odeslani
                        exit();
                    }
                }

                echo '<h2>Registrace</h2>
                <form method="post">
                <p>E-mail: <input type="email" name="email" maxlength="50" required><br>
                Heslo: <input type="password" name="heslo" required><br>
                <input type="submit" value="Přihlásit se"></p>
                </form>

                <p><a href="prihlaseni.php">Zpět na přihlášení</a></p>';
            }
            else if(isset($_GET["overeni"]) && isset($_GET["kod"])){
                $email = $_GET["overeni"];
                $kod = $_GET["kod"];
                $dotaz = $db->prepare("SELECT id FROM uzivatele WHERE email LIKE ? AND kod LIKE ?");
                $dotaz->bind_param("ss", $email, $kod);
                $dotaz->execute();
                $vysledek = $dotaz->get_result();
                if($vysledek->num_rows == 1){           // souhlasi
                    $dotaz = $db->prepare("UPDATE uzivatele SET kod = NULL WHERE email LIKE ?");
                    $dotaz->bind_param("s", $email);
                    $dotaz->execute();
                    echo'<h2>Ověřeno</h2>
                    <p>Pokračujte na přihlášení <a href="prihlaseni.php">Zde</a></p>';
                }
                else{                                   //chybny email nebo kod
                    echo'<h2>Chyba při ověřování</h2>
                    <p>Při ověření emailu nastala chyba. Email či kod nebyl nalezen.</p>';
                }
            }

            else{                                       //nutno se prihlasit
                if(isset($_POST["email"]) && isset($_POST["heslo"])){       //byl odeslan formular
                    $email = $_POST["email"];
                    $heslo = $_POST["heslo"];
                    $heslo = hash("sha512", $heslo);
                    $heslo = "nějaká sůl".$heslo."plus pepř";
                    $heslo = hash("sha512", $heslo);

                    $dotaz = $db->prepare("SELECT kod, obnova, platnost FROM uzivatele WHERE email LIKE ? AND heslo LIKE ?");
                    $dotaz->bind_param("ss", $email, $heslo);
                    $dotaz->execute();
                    $vysledek = $dotaz->get_result();

                    if($vysledek->num_rows == 1){       // email a heslo je v poradku
                        $data = $vysledek->fetch_assoc();
                        if($data["kod"] == NULL){
                            $_SESSION["email"] = $email;
                            if($data["obnova"] != NULL || $data["platnost"] != NULL){
                                $dotaz = $db->prepare("UPDATE uzivatele SET obnova = NULL, platnost = NULL WHERE email LIKE ?");
                                $dotaz->bind_param("s", $email);
                                $dotaz->execute();
                            }
                            header("location:prihlaseni.php");
                        }
                        else{               //existuje overovaci kod = neovereny email
                            echo '<h2>E-Mail nebyl ověřen</h2>
                            <p>Před přihlášením je nutno ověřit email adresu.</p>
                            <p>Na Váš E-Mail byl znovu odeslan overovaci kod.</p>';

                            $kod = $data["kod"];
                            $text = '<h1>Potvrzeni registrace</h1>
                            <p>Dobrý den,<br>
                            pro potvrzeni registrace kliknete na nasledujici odkaz<br>
                            <a href="http://localhost/dinhth/prihlaseni.php?overeni='.$email.'&kod='.$kod.'">http://localhost/dinhth/prihlaseni.php?overeni='.$email.'&kod='.$kod.'</a></p>';
                            echo $text;
                            exit();
                        }
                    }
                    else{
                        echo'<h2 style="color:red">E-mail nebo Heslo nesouhlasí.</h2>
                        <p><a href="prihlaseni.php">Zpět na přihlášení</a><br>
                        <a href="prihlaseni.php?zapomenuteheslo">Zapomenuté heslo</a></p>';
                    }
                }
                else if(isset($_GET["zapomenuteheslo"])){
                    echo '<h2>Zapomenuté heslo</h2>';
                    if(isset($_POST["email"])){
                        $email =  $_POST["email"];
                        $dotaz = $db->prepare("SELECT id FROM uzivatele WHERE email LIKE ?");
                        $dotaz->bind_param("s", $email);
                        $dotaz->execute();
                        $vysledek = $dotaz->get_result();
                        if($vysledek->num_rows == 1){       // email byl nalezen v databazi
                            $kod = hash("sha512", time().$email.rand());    // hash
                            $obnova = substr($kod, rand(0,10), 1).substr($kod, rand(10,20), 3).substr($kod, rand(20,50), 5).substr($kod, rand(50,80), 3).substr($kod, rand(80,120), 3);
                            $platnost = time() + 60*60; // čas + 1h
                            $dotaz = $db->prepare("UPDATE uzivatele SET obnova = ?, platnost = ? WHERE email LIKE ?");
                            $dotaz->bind_param("sis", $obnova, $platnost, $email);
                            $dotaz->execute();
                            echo '<p> Na zadaný e-mail byl zaslán ověřovací kód.</p>';
                            $textmailu = '<p>Pro obnovení emailu pokračujte na stránku:<br>
                            <a href="http://localhost/dinhth/prihlaseni.php?obnova='.$email.'&kod='.$obnova.'">http://localhost/dinhth/prihlaseni.php?obnova='.$email.'&kod='.$obnova.'</a></p>';
                            echo $textmailu;
                        }  
                        else{   //email neni v DB
                            echo'<h2 style="color:red">E-mail nebyl nalezen</h2>';
                        }
                    }
                    else{   //formular pro zaslani kodu
                        echo '<form method="post">
                        <p>E-mail: <input type="email" name="email" required><br>
                        <input type="submit" value="Obnovit"></p>
                        </form>';
                    }
                }
                else if(isset($_GET["obnova"]) && isset($_GET["kod"])){     //klik na obnoveni z emailu
                    $email = $_GET["obnova"];
                    $obnova = $_GET["kod"];
                    $dotaz = $db->prepare("SELECT platnost FROM uzivatele WHERE obnova LIKE ? AND email LIKE ?");
                    $dotaz->bind_param("ss", $obnova, $email);
                    $dotaz->execute();
                    $vysledek = $dotaz-> get_result();
                    if($vysledek->num_rows == 1){   // email a kod souhlasi, ale musime overit
                        $data = $vysledek->fetch_assoc();
                        if($data["platnost"] > time()){     // kod je platny
                            if(isset($_POST["heslo"])){
                                $heslo = $_POST["heslo"];
                                $heslo = hash("sha512", $heslo);
                                $heslo = "nějaká sůl".$heslo."plus pepř";
                                $heslo = hash("sha512", $heslo);
                                $dotaz = $db->prepare("UPDATE uzivatele SET heslo = ?, obnova = NULL, platnost = NULL WHERE email LIKE ?");
                                $dotaz->bind_param("ss", $heslo, $email);
                                $dotaz->execute();
                                echo '<h2>Obnovení hesla</h2>
                                <p>Heslo bylo změněno. Pokračujte na <a href="prihlaseni.php">hlavni stránku</a></p>';
                            }
                            else{
                                $platnost = time() + 600;
                                $dotaz = $db->prepare("UPDATE uzivatele SET platnost = ? WHERE email LIKE ?");
                                $dotaz->bind_param("is", $platnost, $email);
                                $dotaz->execute();
                                // uzivatel ma 10 min na zmeneni hesla
                                echo '<h2>Obnovení hesla</h2>
                                <form method="post">
                                    <p>Nové heslo: <input type="password" name="heslo" required><br>
                                    <input type="submit" value="Změnit"></p>
                                </form>';
                            }
                        }
                        else{   // vyprsel cas
                            echo '<h2>Obnovení hesla</h2>
                            <p>Platnost kódu vypršela. Zažádejte o nový <a href="'.$root.'?zapomenuteheslo">zde</a></p>';
                        }
                    }
                    else{   //email ci kod nebyl nalezen
                        echo '<h2>Obnovení hesla</h2>
                        <p>E-mail či kód nesouhlasí. Pokračujte na <a href="'.$root.'">hlavní stránku</a></p>'; 
                    }
                }
                else{
                    echo '<h2>Přihlášení</h2>
                    <form method="post">
                    <p>E-mail: <input type="email" name="email" maxlength="50" required><br>
                    Heslo: <input type="password" name="heslo" required><br>
                    <input type="submit" value="Přihlásit se"></p>
                    </form>

                    <p>Nemáte zde svůj účet? <a href="prihlaseni.php?registrace">Registrujte se</a><br>
                    <a href="prihlaseni.php?zapomenuteheslo">Zapomenuté heslo</a></p>';
                }
            }
        ?>
    </body>
</html>